/*
 * OBServ TS Services, Copyright (C) 1998 Patrick Alken
 * This program comes with absolutely NO WARRANTY
 *
 * Should you choose to use and/or modify this source code, please
 * do so under the terms of the GNU General Public License under which
 * this program is distributed.  You know the drill.
 */

#include	<stdio.h>
#include	<string.h>
#include	<sys/types.h>
#include	<sys/socket.h>
#include	<netinet/in.h>
#include	<signal.h>
#include	"config.h"
#include  "observ.h"

extern	int		CurrSIndex;
extern	char	ConfigFile;
extern	int		TcmSocket;

char AdminInfo[MAXLINE];

char MyName[MAXLINE];
char MyInfo[MAXLINE];


void join(char *channel)


{
	char	sendstr[MAXLINE];
        time_t CurrTime = time(NULL);
	time_t	timeminus = CurrTime - 901;
#ifdef SJOIN
	sprintf(sendstr, ":%s SJOIN %ld %s + :@%s\n:%s MODE %s +b\n:%s NOTICE %s :Resynching channel with %ld - %ld...\n",
		MyName,
		timeminus,
		channel,
		SERVICENICK,
		SERVICENICK,
		channel,
		SERVICENICK,
		channel,
		CurrTime,
		timeminus);
	writesocket(Servers[CurrSIndex].socket, sendstr);
#endif
#ifndef SJOIN
	sprintf(sendstr, ":%s JOIN %s\n:%s MODE %s +b\n",
		SERVICENICK,
		channel,
		SERVICENICK,
		channel);
	writesocket(Servers[CurrSIndex].socket, sendstr);
#endif
        putlog(LOG1, "[%s] Joining %s", SERVICENICK, channel);
}

#ifdef BOTSERV

void botjoin(char *channel)
{
        char    sendstr[MAXLINE];
        time_t CurrTime = time(NULL);
	int	timeminus = CurrTime - 901;
#ifdef SJOIN
        sprintf(sendstr, ":%s SJOIN %ld %s + :@%s\n:%s MODE %s +b\n:%s NOTICE %s :Resynching channel with %s...\n",
                MyName,
		timeminus,
		channel,
                BOTNICK,
                BOTNICK,
                channel,
		BOTNICK,
		channel,
		MyName);
        writesocket(Servers[CurrSIndex].socket, sendstr);
#endif
#ifndef SJOIN
	sprintf(sendstr, ":%s JOIN %s\n:%s MODE %s +b\n",
		BOTNICK,
		channel,
		BOTNICK,
		channel);
	writesocket(Servers[CurrSIndex].socket, sendstr);
#endif
	putlog(LOG1, "[%s] Joining %s", BOTNICK, channel);
}


void ubotjoin(char *TCBotNick, char *TCBotChan, char *TCBotGreet)
{
        char    sendstr[MAXBUFF];
        time_t CurrTime = time(NULL);
        sprintf(sendstr, ":%s JOIN %s\n:%s NOTICE %s\n",
                TCBotNick,
		TCBotChan,
		TCBotNick,
		TCBotGreet);
        writesocket(Servers[CurrSIndex].socket, sendstr);
	putlog(LOG1, "-ubot- [%s] Joining %s", TCBotNick, TCBotChan);
	putlog(LOG2, sendstr);
}

#endif /* BOTSERV */

void part(char *channel)

{
	char	sendstr[MAXLINE];

	sprintf(sendstr, ":%s NOTICE %s Parting %s...\n:%s PART %s\n",
		SERVICENICK,
		channel,
		channel,
		SERVICENICK,
		channel);
	writesocket(Servers[CurrSIndex].socket, sendstr);
}

/*
Rehash()
	args: none
	purpose: clear all old jupe, gline, and user lists and parse
					 ConfigFile for new ones.
	return: 1 if successful rehash, 0 if not
*/

int Rehash()
{
	int		RehashError = NO;
	FILE	*fp;
	char	line[MAXLINE];
	char	*key;
	char	*lineinfo;
	char	*FileName = &ConfigFile;
	int		ccnt, jcnt, xcnt, wcnt, gcnt, ucnt, ii, jj;
	struct	ChanInfo	tempchans[MAXCHANS];

	if ((fp = fopen(FileName, "r")) == NULL)
		return(YES);

	/* Kill old userlist */	
	for (ii = 0; ii < MAXUSERS; ii++)
		for (jj = 0; jj < MAXLINE; jj++)
		{
			Users[ii].UserHost[jj] = '\0';
			Users[ii].UserPass[jj] = '\0';
			Users[ii].UserFlags[jj] = '\0';
		}	
	/* Kill old ubots list */
	for (ii = 0; ii < MAXLBOTS; ii++)
	{
		ubots[ii].UBotOwn[0] = '\0';
		ubots[ii].UBotNick[0] = '\0';
		ubots[ii].UBotIdent[0] = '\0';
		ubots[ii].UBotName[0] = '\0';
	}
	/* Kill old ubots channel list */
	for (ii = 0; ii < MAXLCBOTS; ii++)
	{
		ucbots[ii].UCBotNick[0] = '\0';
		ucbots[ii].UCBotChan[0] = '\0';
		ucbots[ii].UCBotGreet[0] = '\0';
	}
	/* Kill old jupe list */
	for (ii = 0; ii < MAXJUPES; ii++)
		Jupes[ii].ServName[0] = '\0';
	/* kill old gline list */
	for (ii = 0; ii < MAXGLINES; ii++)
	{
		Glines[ii].GHost[0] = '\0';
		Glines[ii].GReason[0] = '\0';
	}

	for (ii = 0; ii < MAXCHANS; ii++)
		tempchans[ii].ChanName[0] = '\0';

	ccnt = 0;
	for (ii = 0; ii < MAXCHANS; ii++)
	{
		if (channels[ii].ChanName[0] != '\0')
			strcpy(tempchans[ccnt++].ChanName, channels[ii].ChanName);
	}

	/* kill old channel list */
	for (ii = 0; ii < MAXCHANS; ii++)
		channels[ii].ChanName[0] = '\0';
			
	AdminInfo[0] = '\0';

	ucnt = 0;
	jcnt = 0;
	gcnt = 0;
	ccnt = 0;
	xcnt = 0;
	wcnt = 0;
	while (fgets(line, MAXLINE - 1, fp))
	{
		if (line[0] == '#')
			continue;
		key = strtok(line, ":");
		if (key == (char *) NULL)
			continue;
		lineinfo = strtok((char *) NULL, "\r\n");
		if (lineinfo == (char *) NULL)
			continue;
		switch (*key)
		{
			case 'a':
			case 'A':
			{
				strncpy(AdminInfo, lineinfo, MAXLINE - 1);
				break;
			} /* case 'A' */
			case 'u':
			case 'U':
			{
				char	*UsrHost;
				char	*UsrPass;
				char	*UsrFlags;

				UsrHost = strtok(lineinfo, ":");
				UsrPass = strtok((char *) NULL, ":");
				UsrFlags = strtok((char *) NULL, "\r\n");
				if (UsrHost == (char *) NULL)
					continue;
				if (UsrPass == (char *) NULL)
					continue;
				if (UsrFlags == (char *) NULL)
					continue;
				strncpy(Users[ucnt].UserHost, UsrHost, MAXLINE - 1);
				strncpy(Users[ucnt].UserPass, UsrPass, MAXLINE - 1);
				strncpy(Users[ucnt].UserFlags, UsrFlags, MAXLINE - 1);
				ucnt++;
				break;
			} /* case 'U': */
			case 'x':
			case 'X':
			{
				char	*UBotOwn;
				char	*UBotNick;
				char	*UBotIdent;
				char	*UBotName;

				UBotOwn = strtok(lineinfo, ":");
				UBotNick = strtok((char *) NULL, ":");
				UBotIdent = strtok((char *) NULL, ":");
				UBotName = strtok((char *) NULL, "\r\n");
				if (UBotOwn == (char *) NULL)
					continue;
				if (UBotNick == (char *) NULL)
					continue;
				if (UBotIdent == (char *) NULL)
					continue;
				if (UBotName == (char *) NULL)
					continue;
				strncpy(ubots[xcnt].UBotOwn, UBotOwn, MAXLINE - 1);
				strncpy(ubots[xcnt].UBotNick, UBotNick, MAXLINE - 1);
				strncpy(ubots[xcnt].UBotIdent, UBotIdent, MAXLINE - 1);
				strncpy(ubots[xcnt].UBotName, UBotName, MAXLINE - 1);
				xcnt++;
				break;		
			}
			case 'w':
			case 'W':
			{
				char	*UCBotNick;
				char	*UCBotChan;
				char	*UCBotGreet;

				UCBotNick = strtok(lineinfo, ":");
				UCBotChan = strtok((char *) NULL, ":");
				UCBotGreet = strtok((char *) NULL, "\r\n");
				if (UCBotNick == (char *) NULL)
					continue;
				if (UCBotChan == (char *) NULL)
					continue;
				if (UCBotGreet == (char *) NULL)
					continue;
				strncpy(ucbots[wcnt].UCBotNick, UCBotNick, MAXLINE - 1);
				strncpy(ucbots[wcnt].UCBotChan, UCBotChan, MAXLINE - 1);
				strncpy(ucbots[wcnt].UCBotGreet, UCBotGreet, MAXLINE - 1);
				wcnt++;
				break;		
			}
			case 'g':
			case 'G':
			{
				char	*GlineHost;
				char	*GlineReason;

				GlineHost = strtok(lineinfo, ":");
				GlineReason = strtok((char *) NULL, "\r\n");

				if (GlineHost == (char *) NULL)
					continue;
				if (GlineReason == (char *) NULL)
					continue;
				strncpy(Glines[gcnt].GHost, GlineHost, MAXLINE - 1);
				strncpy(Glines[gcnt].GReason, GlineReason, MAXLINE - 1);
				gcnt++;
				break;
			} /* case 'G': */
			case 'c':
			case 'C':
			{
				char	*cname;
				char	*cmodes;
				int		found = 0;

				cname = strtok(lineinfo, ":");
				if (cname == (char *) NULL)
					continue;
				cmodes = strtok((char *) NULL, "\r\n");

			/*	for (ii = 0; ii < MAXCHANS; ii++)
					if (strcasecmp(tempchans[ii].ChanName, cname) == 0)
					{
						found = 1;
						break;
					}
				if (!found)
					for (ii = 0; ii < MAXCHANS; ii++)
						if (tempchans[ii].ChanName[0] == '\0')
						{
							strcpy(tempchans[ii].ChanName, cname);
							printf("adding %s\n", cname);
							break;
						} */

				strncpy(channels[ccnt].ChanName, cname, MAXLINE - 1);
				if (cmodes == (char *) NULL)
					strcpy(channels[ccnt].ChanModes, DEFAULTCHANMODES);
				else
					strncpy(channels[ccnt].ChanModes, cmodes, MAXLINE - 1);
				ccnt++;
				break;
			} /* case 'C' */
			case 'j':
			case 'J':
			{
				char	*SrvName;
				char	*Jreason;

				SrvName = strtok(lineinfo, ":");
				Jreason = strtok((char *) NULL, "\r\n");
				if (SrvName == (char *) NULL)
					continue;
				if (Jreason == (char *) NULL)
					continue;	
				strncpy(Jupes[jcnt].ServName, SrvName, MAXLINE - 1);
				strncpy(Jupes[jcnt].reason, Jreason, MAXLINE - 1);
				jcnt++;
				break;	
			}
		} /* switch (*key) */
	} /* while() */

	if (ucnt == 0)
		RehashError = YES;
	fclose(fp);

	/* /part any channels that have been removed from conf file
		 and /join any new channels */
	CheckChans(tempchans);

	return(RehashError);
}

/*
ProcessSignal()
	args: int sig
	purpose: process system signal specified by 'sig'
	return: none
*/

void ProcessSignal(int sig)

{
	switch (sig)
	{
		case SIGHUP:
		{
			BroadcastDCC(-1, "Recieved signal SIGHUP, rehashing configuration file\n", DCCOPS);
			Rehash();
			putlog(LOG1, "Recieved signal SIGHUP, rehashing configuration file");
			signal(SIGHUP, ProcessSignal);
			break;
		}
		case SIGSEGV:
		case SIGBUS:
		case SIGTERM:
		{
			char	sendstr[MAXLINE];

			sprintf(sendstr, ":%s QUIT :%s\n",
				SERVICENICK,
				"Internal error, shutting down");
			writesocket(Servers[CurrSIndex].socket, sendstr);

			if (sig == SIGSEGV)
				putlog(LOG1, "Recieved signal SIGSEGV, shutting down");
			else
				if (sig == SIGBUS)
					putlog(LOG1, "Recieved signal SIGBUS, shutting down");
				else
					putlog(LOG1, "Recieved signal SIGTERM, shutting down");

			if (sig != SIGTERM)
				abort(); /* make a core file to work with */

			exit(1);
		}
	}
} /* ProcessSignal() */

/*
LoadConfig()
	args: FileName
	purpose: parse config file (FileName) and store server, admin,
					 user, and jupe information
	return: none
*/

void	LoadConfig(char *FileName)
{
	FILE	*fp;
	char	line[MAXLINE];
	char	*key;
	char	*lineinfo;
	int		cnt, scnt, ucnt, jcnt, gcnt, ccnt, bcnt, abcnt, xcnt, wcnt;
	int		ConfError = NO;

	if ((fp = fopen(FileName, "r")) == NULL)
	{
		printf("Unable to open %s\n", FileName);
		exit(0);
	}
	
	for (cnt = 0; cnt < MAXSERVS; cnt++)
	{
		Servers[cnt].ServHost[0] = '\0';
		Servers[cnt].ConnectPass[0] = '\0';
	}
	for (cnt = 0; cnt < MAXUSERS; cnt++)
	{
		Users[cnt].UserHost[0] = '\0';
		Users[cnt].UserPass[0] = '\0';
		Users[cnt].UserFlags[0] = '\0';
	}
	for (cnt = 0; cnt < MAXLCBOTS; cnt++)
	{
		ucbots[cnt].UCBotNick[0] = '\0';
		ucbots[cnt].UCBotChan[0] = '\0';
		ucbots[cnt].UCBotGreet[0] = '\0';
	}
	for (cnt = 0; cnt < MAXJUPES; cnt++)
		Jupes[cnt].ServName[0] = '\0';
	for (cnt = 0; cnt < MAXGLINES; cnt++)
		Glines[cnt].GHost[0] = '\0';
	for (cnt = 0; cnt < MAXLBOTS; cnt++)
	{
		ubots[cnt].UBotOwn[0] = '\0';
		ubots[cnt].UBotNick[0] = '\0';
		ubots[cnt].UBotIdent[0] = '\0';
		ubots[cnt].UBotName[0] = '\0';
	}
	for (cnt = 0; cnt < MAXBOTS; cnt++)
	{
		bots[cnt].BotName[0] = '\0';
		AllowedBots[cnt].BotName[0] = '\0';
	}
	AdminInfo[0] = '\0';
	MyName[0] = '\0';
	MyInfo[0] = '\0';
  
	scnt = 0;
	ucnt = 0;
	jcnt = 0;
	gcnt = 0;
	ccnt = 0;
	bcnt = 0;
	abcnt = 0;
	xcnt = 0;
	wcnt = 0;
	while (fgets(line, MAXLINE - 1, fp))
	{
		if (line[0] == '#') /* you may add comments to config file */
			continue;       /* with the first character a '#'      */
		key = strtok(line, ":");
		if (key == (char *) NULL)
			continue;
		lineinfo = strtok((char *) NULL, "\r\n");
		if (lineinfo == (char *) NULL)
			continue;
		switch (*key)
		{
			case 'a':
			case 'A':
				strncpy(AdminInfo, lineinfo, MAXLINE - 1);
				break;
			case 's':
			case 'S':
			{
				char *SrvPass;
				char *SrvHost;
				char *SrvPort;
				int  port = DEFAULTPORT;
				
				SrvPass = strtok(lineinfo, ":");
				SrvHost = strtok((char *) NULL, ":");
				SrvPort = strtok((char *) NULL, ":");
				if (SrvHost == (char *) NULL)
					continue;
				if (SrvPort == (char *) NULL)
					SrvPort = strtok((char *) NULL, "\r\n");
				if (SrvPort == (char *) NULL)
					sprintf(Servers[scnt].ConnectPort, "%d", port);
				else
					strncpy(Servers[scnt].ConnectPort, SrvPort, MAXLINE - 1);
				strncpy(Servers[scnt].ServHost, SrvHost, MAXLINE - 1);
				strncpy(Servers[scnt].ConnectPass, SrvPass, MAXLINE - 1);
				scnt++;
				break;
			}
			case 'j':
			case 'J':
			{
				char	*SrvName;
				char	*Jreason;

				SrvName = strtok(lineinfo, ":");
				Jreason = strtok((char *) NULL, "\r\n");
				if (SrvName == (char *) NULL)
					continue;
				if (Jreason == (char *) NULL)
					continue;	
				strncpy(Jupes[jcnt].ServName, SrvName, MAXLINE - 1);
				strncpy(Jupes[jcnt].reason, Jreason, MAXLINE - 1);
				jcnt++;
				break;	
			}
			case 'g':
			case 'G':
			{
				char	*GlineHost;
				char	*GlineReason;

				GlineHost = strtok(lineinfo, ":");
				GlineReason = strtok((char *) NULL, "\r\n");
				if (GlineHost == (char *) NULL)
					continue;
				if (GlineReason == (char *) NULL)
					continue;
				strncpy(Glines[gcnt].GHost, GlineHost, MAXLINE - 1);
				strncpy(Glines[gcnt].GReason, GlineReason, MAXLINE - 1);
				gcnt++;
				break; 		
			} /* case 'G': */
			case 'c':
			case 'C':
			{
				char	*cname;
				char	*cmodes;

				cname = strtok(lineinfo, ":");
				if (cname == (char *) NULL)
					continue;
				cmodes = strtok((char *) NULL, "\r\n");
				strncpy(channels[ccnt].ChanName, cname, MAXLINE - 1);
				if (cmodes == (char *) NULL)
					strcpy(channels[ccnt].ChanModes, DEFAULTCHANMODES);
				else
					strncpy(channels[ccnt].ChanModes, cmodes, MAXLINE - 1);
				ccnt++;
				break;
			} /* case 'C' */
			case 'u':
			case 'U':
			{
				char	*UsrHost;
				char	*UsrPass;
				char	*UsrFlags;

				UsrHost = strtok(lineinfo, ":");
				UsrPass = strtok((char *) NULL, ":");
				UsrFlags = strtok((char *) NULL, "\r\n");
				if (UsrHost == (char *) NULL)
					continue;
				if (UsrPass == (char *) NULL)
					continue;
				if (UsrFlags == (char *) NULL)
					continue;
				strncpy(Users[ucnt].UserHost, UsrHost, MAXLINE - 1);
				strncpy(Users[ucnt].UserPass, UsrPass, MAXLINE - 1);
				strncpy(Users[ucnt].UserFlags, UsrFlags, MAXLINE - 1);
				ucnt++;
				break;		
			}
			case 'x':
			case 'X':
			{
				char	*UBotOwn;
				char	*UBotNick;
				char	*UBotIdent;
				char	*UBotName;

				UBotOwn = strtok(lineinfo, ":");
				UBotNick = strtok((char *) NULL, ":");
				UBotIdent = strtok((char *) NULL, ":");
				UBotName = strtok((char *) NULL, "\r\n");
				if (UBotOwn == (char *) NULL)
					continue;
				if (UBotNick == (char *) NULL)
					continue;
				if (UBotIdent == (char *) NULL)
					continue;
				if (UBotName == (char *) NULL)
					continue;
				strncpy(ubots[xcnt].UBotOwn, UBotOwn, MAXLINE - 1);
				strncpy(ubots[xcnt].UBotNick, UBotNick, MAXLINE - 1);
				strncpy(ubots[xcnt].UBotIdent, UBotIdent, MAXLINE - 1);
				strncpy(ubots[xcnt].UBotName, UBotName, MAXLINE - 1);
				xcnt++;
				break;		
			}
			case 'w':
			case 'W':
			{
				char	*UCBotNick;
				char	*UCBotChan;
				char	*UCBotGreet;

				UCBotNick = strtok(lineinfo, ":");
				UCBotChan = strtok((char *) NULL, ":");
				UCBotGreet = strtok((char *) NULL, "\r\n");
				if (UCBotNick == (char *) NULL)
					continue;
				if (UCBotChan == (char *) NULL)
					continue;
				if (UCBotGreet == (char *) NULL)
					continue;
				strncpy(ucbots[wcnt].UCBotNick, UCBotNick, MAXLINE - 1);
				strncpy(ucbots[wcnt].UCBotChan, UCBotChan, MAXLINE - 1);
				strncpy(ucbots[wcnt].UCBotGreet, UCBotGreet, MAXLINE - 1);
				wcnt++;
				break;		
			}
			case 'n':
			case 'N':
			{
				char	*Sname;
				char	*Sinfo;

				Sname = strtok(lineinfo, ":");
				Sinfo = strtok((char *) NULL, "\r\n");
				if (Sname == (char *) NULL)
					continue;
				strncpy(MyName, Sname, MAXLINE - 1);
				if (Sinfo == (char *) NULL)
					continue;
				strncpy(MyInfo, Sinfo, MAXLINE - 1);
				break;
			}
			case 'b':
			case 'B':
			{
				char	*bname;
				char	*bhost;
				char	*bpass;
				char	*bport;
				int		port = DEFAULTTCMPORT;

				bhost = strtok(lineinfo, ":");
				bname = strtok((char *) NULL, ":");
				bpass = strtok((char *) NULL, ":");
				bport = strtok((char *) NULL, ":");
				if ((bname == (char *) NULL) || (bhost == (char *) NULL) ||
						(bpass == (char *) NULL))
					continue;
				if (bport == (char *) NULL)
					bport = strtok((char *) NULL, "\r\n");
				if (bport == (char *) NULL)
					sprintf(bots[bcnt].BotPort, "%d", port);
				else
					strncpy(bots[bcnt].BotPort, bport, MAXLINE - 1);
				strncpy(bots[bcnt].BotName, bname, MAXLINE - 1);
				strncpy(bots[bcnt].BotHost, bhost, MAXLINE - 1);
				strncpy(bots[bcnt].BotPass, bpass, MAXLINE - 1);
				bcnt++;
				break;
			}
			case 'l':
			case 'L':
			{
				char	*bname;
				char	*bhost;
				char	*bpass;
				int		port = DEFAULTTCMPORT;

				bhost = strtok(lineinfo, ":");
				bname = strtok((char *) NULL, ":");
				bpass = strtok((char *) NULL, "\r\n");
				if ((bname == (char *) NULL) || (bhost == (char *) NULL) ||
						(bpass == (char *) NULL))
					continue;
				strncpy(AllowedBots[abcnt].BotName, bname, MAXLINE - 1);
				strncpy(AllowedBots[abcnt].BotHost, bhost, MAXLINE - 1);
				strncpy(AllowedBots[abcnt].BotPass, bpass, MAXLINE - 1);
				abcnt++;
				break;
			}

			default:
				break;
		}
	}

	if (AdminInfo[0] == '\0')
	{
		fprintf (stderr, "No administrative contact information (A:) found in %s\n", FileName);
		ConfError = YES;
	}
	if (MyName[0] == '\0')
	{
		fprintf (stderr, "No server name (N:) specified in %s\n", FileName);
		ConfError = YES;
	}
	if (MyInfo[0] == '\0')
	{
		fprintf (stderr, "No server info (N:) specified in %s\n", FileName);
		ConfError = YES;
	}
	if (scnt == 0)
	{
		fprintf (stderr, "No hub servers (S:) specified to connect to in %s\n", FileName);
		ConfError = YES;
	}
	if (ucnt == 0)
	{
		fprintf (stderr, "No users (U:) specified for access to services in %s (at least one user should be added)\n", FileName);
		ConfError = YES;
	}
	fclose(fp);
	if (ConfError)
		exit(1);
/*
	ubots[xcnt].UBotOwn = '\0';
	ubots[xcnt].UBotNick = '\0';
	ubots[xcnt].UBotIdent = '\0';
	ubots[xcnt].UBotName = '\0';
*/
	printf("Stored %d users, %d channels, %d glines, and %d servers (%d jupes)\n", ucnt, ccnt, gcnt, scnt, jcnt);
	putlog(LOG1, "Successfully parsed configuration file (%s).  Stored %d users, %d channels, %d glines, %d servers, and %d jupes", FileName, ucnt, ccnt, gcnt, scnt, jcnt);
}

void InitListenPort()

{
	struct sockaddr_in socketname;

	bzero(&socketname, sizeof(struct sockaddr));
	socketname.sin_family = AF_INET;
	socketname.sin_addr.s_addr = INADDR_ANY;
	socketname.sin_port = htons(LISTEN_PORT);
	
	if((TcmSocket = socket(PF_INET, SOCK_STREAM, 6)) < 0)
	{
		putlog(LOG1, "Unable to create socket for %d, exiting", LISTEN_PORT);
		exit(1);
	}

	if(bind(TcmSocket, (struct sockaddr *)&socketname, sizeof(socketname)) < 0)
	{
		putlog(LOG1, "Unable to bind remote tcm port %d, exiting", LISTEN_PORT);
		exit(1);
	}

	if (listen(TcmSocket, 4) < 0)
	{
		putlog(LOG1, "Unable to listen on remote tcm port %d, exiting", LISTEN_PORT);
		exit(1);
	}
} /* InitListenPort() */

/*
signon()
	args: none
	purpose: send a PASS and SERVER string to make a connection 
	return: void
*/

void signon()
{
	char	sendstr[MAXBUFF];

	putlog(LOG1, "Attempting to signon to %s", Servers[CurrSIndex].ServHost);
	(void)sprintf(sendstr, "PASS %s :TS\nCAPAB :EX DE\nSERVER %s 1 :%s\n", 
		Servers[CurrSIndex].ConnectPass, 
		MyName, 
		MyInfo); 
	writesocket(Servers[CurrSIndex].socket, sendstr);
}

/*
InitServs()
	args: none
	purpose: introduce SERVICENICK & BOTSERV to the network after a successful
					 connection
	return: none
*/

void conn(char *BotNick, char *BotIdent, char *BotName, char *BotOwn)
{
	char sendstr[MAXBUFF];
	time_t CurrTime = time(NULL);
	(void)sprintf(sendstr, "NICK %s 1 %ld + %s %s.4651.org %s :%s\n",
				BotNick,
				CurrTime,
				BotIdent,
				BotOwn,
				MyName,
				BotName);
        writesocket(Servers[CurrSIndex].socket, sendstr);
	putlog(LOG1, "Bot %s [%s] has signed on", BotNick, BotOwn);
}

void InitServs()
{
	char	sendstr[MAXBUFF];
	time_t CurrTime = time(NULL);
	int		ii;
	
	 (void)sprintf(sendstr, "NICK %s 1 %ld %s %s %s %s :%s\n", 
	 			SERVICENICK,
	 			CurrTime,
	 			SERVICEUMODES,
	 			SERVICEIDENT,
	 			MyName,
	 			MyName,
	 			MyInfo);
		writesocket(Servers[CurrSIndex].socket, sendstr);
#ifdef BOTSERV
         (void)sprintf(sendstr, "NICK %s 1 %ld %s %s %s %s :%s\n",
                                BOTNICK,
                                CurrTime,
                                BOTMODE,
                                SERVICEIDENT,
                                MyName,
                                MyName,
                                BOTRNAME);
                writesocket(Servers[CurrSIndex].socket, sendstr);
#endif /* BOTSERV */

#ifdef CHANNELSERVICES
		/* Have OBServ join the channels it's monitoring */
		for (ii = 0; ii < MAXCHANS; ii++)
		{
			if (channels[ii].ChanName[0] == '\0') {
				continue;
			} else {
			join(channels[ii].ChanName);
#ifdef BOTSERV
			botjoin(channels[ii].ChanName);
#endif /* BOTSERV */
			}
		}
	    for (ii = 0; ii < MAXLCBOTS; ii++)
	    {
		    if (ucbots[ii].UCBotChan[0] == '\0') {
			    continue;
		    } else {
			ubotjoin(ucbots[ii].UCBotNick, ucbots[ii].UCBotChan, ucbots[ii].UCBotGreet);
		    };
	    }

#endif
	
#ifdef BOTSERV
		/* Have Bots connecting to network */
		for (ii = 0; ii < MAXLBOTS; ii++)
		{
			if (ubots[ii].UBotNick[0] == '\0') {
				continue;
			} else {
				char senstr[MAXBUFF];
				time_t CurrTime = time(NULL);
				(void)sprintf(sendstr, "NICK %s 1 %ld + %s %s.4651.org %s :%s\n",
							ubots[ii].UBotNick,
							CurrTime,
							ubots[ii].UBotIdent,
							ubots[ii].UBotOwn,
							MyName,
							ubots[ii].UBotName);
			        writesocket(Servers[CurrSIndex].socket, sendstr);
				putlog(LOG1, "Bot %s [%s] has signed on", ubots[ii].UBotNick, ubots[ii].UBotOwn);
			}
		}
	    for (ii = 0; ii < MAXLCBOTS; ii++)
	    {
		    if (ucbots[ii].UCBotChan[0] == '\0') {
			    continue;
		    } else {
			ubotjoin(ucbots[ii].UCBotNick, ucbots[ii].UCBotChan, ucbots[ii].UCBotGreet);
		    }
	    }
#endif /* BOTSERV */
	putlog(LOG1, "Successfully initialized %s", SERVICENICK);

}
